var ToodledoLoaded = false;

var ToodledoVars = { key: null, url: null, selectedText: null } ;
var ToodledoFolders = new Array();
var ToodledoFolderIds = new Array();
var ToodledoContexts = new Array();
var ToodledoContextIds = new Array();
var ToodledoGoals = new Array();
var ToodledoGoalIds = new Array();
var ToodledoLocations = new Array();
var ToodledoLocationIds = new Array();

function Toodledo_Init() {
	if(ToodledoLoaded == false) {
		Toodledo_Log("1.71");
		ToodledoLoaded = true;
		XULToodledoChrome.branch.setBoolPref("toodledopref_proLoaded", false);
		
		ToodledoUpdateContext();
		
		var menu = document.getElementById("contentAreaContextMenu");
		menu.addEventListener('popupshowing', ToodledoUpdateContext, false);
	}
}

function Toodledo_UrlLoaded() {
	var res=XULToodledoChrome.httpRequest.responseText;
	var xml=XULToodledoChrome.httpRequest.responseXML;
	
	//Toodledo_Log("toodledo.js: "+res);	

	if(xml.firstChild) {
		var root_node = xml.firstChild.tagName;
		
		if(root_node=="userid") {
		
			var userid = xml.firstChild.textContent;
			if(userid==0) {
				//we only get here if the password was never entered correctly
				Toodledo_setPassword("");
			} else if(userid==1) {
				//we only get here if the password was never entered correctly
				Toodledo_setPassword("");
			} else {
				XULToodledoChrome.branch.setCharPref("toodledopref_userid", userid);
				ToodledoGetAPIKey(); //once we get a userid, try to get a key
			}
			
		} else if(root_node=="token") {
			var email = XULToodledoChrome.branch.getCharPref("toodledopref_email");
			var token = xml.firstChild.textContent;
			var password = Toodledo_GetPassword(email);
			var userid = XULToodledoChrome.branch.getCharPref("toodledopref_userid");
			
			ToodledoVars.key = ToodledoMD5(ToodledoMD5(password)+token+userid);
			
		} else if(root_node=="added") {
		
			var added = xml.firstChild.textContent;
			
			
		} else if(root_node=="folders") {
			//Toodledo_Log("folders1");
			var folders = xml.firstChild;
			
			var j=0;
			for(var i=0;i<folders.childNodes.length;i++) {
				if(folders.childNodes[i].attributes[2].value==0) { //hide archived folders
					ToodledoFolders[j] = folders.childNodes[i].textContent;
					ToodledoFolderIds[j] = folders.childNodes[i].attributes[0].value;
					j++;
				}
			}
						
		} else if(root_node=="contexts") {
			//Toodledo_Log("contexts1");
			var contexts = xml.firstChild;
			
			for(var i=0;i<contexts.childNodes.length;i++) {
				ToodledoContexts[i] = contexts.childNodes[i].textContent;
				ToodledoContextIds[i] = contexts.childNodes[i].attributes[0].value;
				//if(contexts.childNodes[i].attributes[1].value==1) ToodledoContextIds[999] = contexts.childNodes[i].attributes[0].value;//default
			}
			
		} else if(root_node=="goals") {
			//Toodledo_Log("goals");
			var goals = xml.firstChild;
			
			var j = 0;
			for(var i=0;i<goals.childNodes.length;i++) {
				if(goals.childNodes[i].attributes[3].value==0) { //hide archived goals
					ToodledoGoals[j] = goals.childNodes[i].textContent;
					ToodledoGoalIds[j] = goals.childNodes[i].attributes[0].value;
					
					if(goals.childNodes[i].attributes[1].value==0) ToodledoGoals[j] += " (Lifelong)";
					else if(goals.childNodes[i].attributes[1].value==1) ToodledoGoals[j] += " (Long-term)";
					else if(goals.childNodes[i].attributes[1].value==2) ToodledoGoals[j] += " (Short-term)";
						
					j++;
				}
			}
			
		} else if(root_node=="locations") {
			//Toodledo_Log("locations");
			var locations = xml.firstChild;
			
			for(var i=0;i<locations.childNodes.length;i++) {
				ToodledoLocations[j] = locations.childNodes[i].textContent;
				ToodledoLocationIds[j] = locations.childNodes[i].attributes[0].value;
			}
			
		} else if(root_node=="account") {
			
			var account = xml.firstChild;
			
			for(var i=0;i<account.childNodes.length;i++) {
				if(account.childNodes[i].tagName=="pro" && account.childNodes[i].textContent=="1") XULToodledoChrome.branch.setBoolPref("toodledopref_pro", true);
				else if(account.childNodes[i].tagName=="pro") XULToodledoChrome.branch.setBoolPref("toodledopref_pro", false);
			}
			XULToodledoChrome.branch.setBoolPref("toodledopref_proLoaded", true);
			
		} else if(root_node=="tasks") {

			
		} else if(root_node=="error") {
			var error_value = xml.firstChild.textContent;
			Toodledo_Log(error_value);	
			
			if(error_value=="key did not validate") {  //perhaps the key expired. Try one more time
				if(XULToodledoChrome.TryOnce) {
					var strbundle = document.getElementById("toodledostrings");
					alert(strbundle.getString("error"));
					XULToodledoChrome.branch.setCharPref("toodledopref_userid", ""); //userid is not valid anymore
					Toodledo_setPassword("");
					XULToodledoChrome.TryOnce=0;
				} else {
					ToodledoGetAPIKey();
					XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddTask()",1000); //try again in 1 second
					XULToodledoChrome.TryOnce++;
				}
				
			} else if(error_value=="App blocked by user") {
				XULToodledoChrome.branch.setCharPref("toodledopref_userid", ""); //userid is not valid anymore
				Toodledo_setPassword("");
			} else if(error_value=="invalid userid") {

			} else if(error_value=="no userid specified") {

			} 
		} else {
			Toodledo_Log("Unknown response from toodledo.com");	
		}
	
	}
}

//does the ajax to add the task.
function Toodledo_AddTask() {	
	if(XULToodledoChrome.timeoutID!=0) clearTimeout(XULToodledoChrome.timeoutID); //if there is a timeout, clear it
	
	if(!ToodledoVars.key) {
		if(XULToodledoChrome.TryOnce) {
			var strbundle = document.getElementById("toodledostrings");
			alert(strbundle.getString("error"));
			XULToodledoChrome.TryOnce=0;
		} else {
			ToodledoGetAPIKey();
			XULToodledoChrome.timeoutID = setTimeout("Toodledo_AddTask()",2000); //try again in 2 seconds
			XULToodledoChrome.TryOnce++;
		}
				
	} else {
		Toodledo_GetUrl(ToodledoVars.url,true,ToodledoVars.key);
	}
}

//========= TOOLS MENU ========================================================================


function Toodledo_add() {
	var userid = XULToodledoChrome.branch.getCharPref("toodledopref_userid");
	ToodledoVars.selectedText = "";
	XULToodledoChrome.TryOnce=0;
	if(userid) {
		window.openDialog("chrome://toodledo/content/add.xul", "Toodledo-Add", "centerscreen,chrome,modal,resizable",ToodledoVars,ToodledoFolders,ToodledoFolderIds,ToodledoContexts,ToodledoContextIds,ToodledoGoals,ToodledoGoalIds,ToodledoLocations,ToodledoLocationIds);
		if(ToodledoVars.url) Toodledo_AddTask();
	
	} else {
		var strbundle = document.getElementById("toodledostrings");
		alert(strbundle.getString("error2"));
	}
}

function Toodledo_refresh() {
	//unload folders, contexts and goals
	//Toodledo_Log("Refresh");
	
	ToodledoFolders = new Array();
	ToodledoFolderIds = new Array();
	ToodledoContexts = new Array();
	ToodledoContextIds = new Array();
	ToodledoGoals = new Array();
	ToodledoGoalIds = new Array();
	ToodledoLocations = new Array();
	ToodledoLocationIds = new Array();
	XULToodledoChrome.branch.setBoolPref("toodledopref_proLoaded", false);
} 

function Toodledo_options() {
	window.openDialog("chrome://toodledo/content/options.xul", "Toodledo-Options", "centerscreen,chrome,modal,resizable",ToodledoVars);
}


//========= CONTEXT MENU ========================================================================

function ToodledoUpdateContext() {
	ToodledoVars.selectedText = Toodledo_getSelection();
	var userid = XULToodledoChrome.branch.getCharPref("toodledopref_userid");
	var strbundle = document.getElementById("toodledostrings");
	var isLink = false;
	if(document.getElementById("context-copylink") && document.getElementById("context-copylink").hidden==false) isLink=true; //determine if right clicking on link
	
	
	if(userid && ToodledoVars.selectedText) { //if text selected
		document.getElementById("toodledo.context.add").label = strbundle.getString("toodledo")+" \""+ToodledoVars.selectedText.substr(0,20)+"...\"";
		document.getElementById("toodledo.context.add").hidden = false; //Modify "Toodeldo Something..." to "Toodledo 'selected text'"
	} else if(userid) { //nothing was selected, return to "Toodledo Something..."
		document.getElementById("toodledo.context.add").label = strbundle.getString("something");
		document.getElementById("toodledo.context.add").hidden = false;
	} else {
		if(XULToodledoChrome.TryOnce) {
			XULToodledoChrome.TryOnce=0;
		} else {
			XULToodledoChrome.timeoutID = setTimeout("ToodledoUpdateContext()",1000); //try again in 1 second
			Toodledo_GetUserId();
			XULToodledoChrome.TryOnce++;
		}
		
		document.getElementById("toodledo.context.add").hidden = true;
		document.getElementById("toodledo.context.sep").hidden = true;
	}
	
	if(gContextMenu && userid && isLink) { //right clicking on link
		ToodledoVars.selectedText = gContextMenu.linkText()+" : "+gContextMenu.linkURL;
		//turn on "Toodledo Link" menu and update the label
		document.getElementById("toodledo.context.addlink").label = strbundle.getString("link");
		document.getElementById("toodledo.context.addlink").hidden = false;
	} else {
		document.getElementById("toodledo.context.addlink").hidden = true; //hide it because we are not clicking on a link
	}
}

function Toodledo_getCurrentPage() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	
	return focusedWindow.location.href;
}

function Toodledo_addtext(isLink) {
	if(!isLink) ToodledoVars.selectedText = Toodledo_getSelection(); //Clicked "Toodledo Something" or "Toodeldo 'selected text'"
	else if(isLink==2) ToodledoVars.selectedText = Toodledo_getCurrentPage(); //Clicked "Toodledo this page"
	//value 1 is already set from the ToodeldoUpdateContext call
	
	XULToodledoChrome.TryOnce=0;
	window.openDialog("chrome://toodledo/content/add.xul", "Toodledo-Add", "centerscreen,chrome,modal,resizable",ToodledoVars,ToodledoFolders,ToodledoFolderIds,ToodledoContexts,ToodledoContextIds,ToodledoGoals,ToodledoGoalIds,ToodledoLocations,ToodledoLocationIds);
	if(ToodledoVars.url) Toodledo_AddTask();
}

function Toodledo_getSelection() {
    var focusedWindow = document.commandDispatcher.focusedWindow;
    var selection = "";
    if(focusedWindow) selection = focusedWindow.getSelection();
    return String(selection);
}

